//
// This file is part of Nolimips, a MIPS simulator with unlimited registers
// Copyright (C) 2005, 2006 Benoit Perrot <benoit@lrde.epita.fr>
//
// Nolimips is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// Nolimips is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Nolimips.  If not, see <http://www.gnu.org/licenses/>.
//
#include "inst/op_exp.hh"
#include "inst/exp-visitor.hh"

namespace inst
{

  OpExp::~OpExp()
  {
    // FIXME: delete left;
    // FIXME: delete right;
  }

  void
  OpExp::accept (ConstExpVisitor& v) const
  {
    v.visit(*this);
  }

  void
  OpExp::accept (ExpVisitor& v)
  {
    v.visit(*this);
  }

  void
  OpExp::write(std::ostream& ostr) const
  {
    ostr << *left_;
    switch (kind_)
      {
      case add: ostr << " + "; break;
      case sub: ostr << " - "; break;
      case mul: ostr << " * "; break;
      case div: ostr << " / "; break;
      }
    ostr << *right_;
  }

} // namespace inst
