//
// This file is part of Nolimips, a MIPS simulator with unlimited registers
// Copyright (C) 2006 Benoit Perrot <benoit@lrde.epita.fr>
//
// Nolimips is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// Nolimips is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Nolimips.  If not, see <http://www.gnu.org/licenses/>.
//
#ifndef INST_TEXT_LABEL_HXX
# define INST_TEXT_LABEL_HXX

# include "inst/text_label.hh"

# include "misc/contract.hh"

namespace inst
{

  //
  inline
  TextLabel::TextLabel(const std::string &s,
                       TextSection::instruction_list_type::iterator it):
    Label(s), it_(it)
  {
  }

  //
  inline void
  TextLabel::set_offset(int offset)
  {
    precondition(!locked());
    lock();

    offset_ = offset;
  }

  inline const TextSection::instruction_list_type::iterator &
  TextLabel::get_iterator() const
  {
    return it_;
  }

} // namespace inst

#endif // !INST_TEXT_LABEL_HXX
