//
// This file is part of Nolimips, a MIPS simulator with unlimited registers
// Copyright (C) 2005, 2006 Benoit Perrot <benoit@lrde.epita.fr>
//
// Nolimips is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// Nolimips is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Nolimips.  If not, see <http://www.gnu.org/licenses/>.
//
#ifndef VM_SPIM_SYSTEM_LIBRARY_HH
# define VM_SPIM_SYSTEM_LIBRARY_HH

# include <iostream>

# include "vm/system_library.hh"

namespace vm
{

  class SpimSystemLibrary:
    public SystemLibrary
  {
  public:
    SpimSystemLibrary(std::istream &istr, std::ostream &ostr);
    virtual ~SpimSystemLibrary();

  public:
    virtual void invoke(Cpu &cpu);

  protected:
    std::istream &istr_;
    std::ostream &ostr_;
  };

} // namespace vm

# include "vm/spim_system_library.hxx"

#endif // !VM_SPIM_SYSTEM_LIBRARY_HH
